<div class="order-container">
  <mat-card class="order-mat-card">
    <mat-card-content>
      <ng-container *ngIf="(nationality$ | async) as nationalities">
        <ng-container *ngIf="(airportSelectorData$ | async) as airportSelectorData">
          <ng-container *ngIf="(allowedDirections$ | async) as allowedDirections">
            <form class="order-form" [formGroup]="orderForm">

              <div class="main-inputs">
                <div class="airport-selectors">
                  <app-airport-selector
                    [airportSelectorData]="airportSelectorData"
                    [allowedDirections]="allowedDirections"
                    [airport]="orderForm.get('airportFrom')?.value"
                    [airportDirection]="orderForm.get('airportTo')?.value"
                    [placeholder]="'departure from'"
                    [flag]="'from'"
                    (changeAirport)="changeAirportFrom($event)"
                  ></app-airport-selector>

                  <app-airport-selector
                    [airportSelectorData]="airportSelectorData"
                    [allowedDirections]="allowedDirections"
                    [airport]="orderForm.get('airportTo')?.value"
                    [airportDirection]="orderForm.get('airportFrom')?.value"
                    [placeholder]="'arrive to'"
                    [flag]="'to'"
                    (changeAirport)="changeAirportTo($event)"
                  ></app-airport-selector>
                </div>

                <div class="date-selector">
                  <mat-form-field appearance="outline">
                    <mat-label>Departure</mat-label>
                    <input matInput formControlName="departureDate"
                           [matDatepicker]="departureDate"
                           [min]="todayDate"
                           [max]="orderForm.get('arrivalDate')?.value"
                    >
                    <mat-datepicker-toggle matSuffix [for]="departureDate"></mat-datepicker-toggle>
                    <mat-datepicker #departureDate></mat-datepicker>
                    <mat-error *ngIf="orderForm.controls['departureDate']?.hasError('required')">
                      Укажите дату!
                    </mat-error>
                  </mat-form-field>

                  <mat-form-field appearance="outline">
                    <mat-label>Arrival</mat-label>
                    <input matInput [matDatepicker]="arrivalDate" formControlName="arrivalDate"
                           [min]="orderForm.get('departureDate')?.value || todayDate">
                    <mat-datepicker-toggle matSuffix [for]="arrivalDate"></mat-datepicker-toggle>
                    <mat-datepicker #arrivalDate></mat-datepicker>
                    <mat-error *ngIf="orderForm.controls['arrivalDate']?.hasError('required')">
                      Укажите дату!
                    </mat-error>
                  </mat-form-field>

                </div>
              </div>
              <mat-divider class="divider"></mat-divider>
              <button mat-stroked-button color="primary" class="add-passenger-button"
                      (click)="addPassenger(); $event.preventDefault()">Add
                passenger
              </button>
              <ng-container formArrayName="passengers">
                <div class="passengers-container">
                  <mat-card class="passenger" *ngFor="let _ of passengers.controls; index as i" [formGroupName]="i">
                    <mat-card-subtitle>Пассажир {{i + 1}}</mat-card-subtitle>
                    <div class="passenger-inputs">
                      <mat-form-field appearance="outline">
                        <mat-label>First name</mat-label>
                        <input matInput type="text" formControlName="fName">
                        <mat-error *ngIf="passengers.at(i).get('fName')?.hasError('required')">
                          Укажите имя!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Last name</mat-label>
                        <input matInput type="text" formControlName="lName">
                        <mat-error *ngIf="passengers.at(i).get('lName')?.hasError('required')">
                          Укажите фамилию!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Birth date</mat-label>
                        <input matInput [matDatepicker]="birthDate" formControlName="birthdate">
                        <mat-datepicker-toggle matSuffix [for]="birthDate"></mat-datepicker-toggle>
                        <mat-datepicker #birthDate></mat-datepicker>
                        <mat-error *ngIf="passengers.at(i).get('birthdate')?.hasError('required')">
                          Укажите дату рождения!
                        </mat-error>
                        <mat-error *ngIf="passengers.at(i).get('birthdate')?.hasError('errorAge')">
                          Вам менее 20 лет!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Sex</mat-label>
                        <mat-select formControlName="sex">
                          <mat-option *ngFor="let sex of ['Male', 'Female']" [value]="sex">
                            {{sex}}
                          </mat-option>
                        </mat-select>
                        <mat-error *ngIf="passengers.at(i).get('sex')?.hasError('required')">
                          Выберите пол!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Nationality</mat-label>
                        <mat-select formControlName="nationalityId">
                          <mat-option *ngFor="let nationality of nationalities" [value]="nationality.id">
                            {{nationality.name}}
                          </mat-option>
                        </mat-select>
                        <mat-error *ngIf="passengers.at(i).get('nationalityId')?.hasError('required')">
                          Выберите национальность!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Document type</mat-label>
                        <mat-select formControlName="documentType">
                          <mat-option *ngFor="let type of [1,2,3]" [value]="type"
                                      (click)="setDocumentExpiresValidator(type, i)">
                            {{documentType[type]}}
                          </mat-option>
                        </mat-select>
                        <mat-error *ngIf="passengers.at(i).get('documentType')?.hasError('required')">
                          Выберите тип документа!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Passport No</mat-label>
                        <input matInput type="number" formControlName="passportNo">
                        <mat-error *ngIf="passengers.at(i).get('passportNo')?.hasError('required')">
                          Необходимо заполнить поле!
                        </mat-error>
                      </mat-form-field>

                      <mat-form-field appearance="outline">
                        <mat-label>Date of expire</mat-label>
                        <input matInput [matDatepicker]="dateOfExpire" formControlName="passportDateOfExpire"
                               [min]="todayDate">
                        <mat-datepicker-toggle matSuffix [for]="dateOfExpire"></mat-datepicker-toggle>
                        <mat-datepicker #dateOfExpire></mat-datepicker>
                        <mat-error *ngIf="passengers.at(i).get('passportDateOfExpire')?.hasError('errorExpire')">
                          Срок действия паспорта истекает!
                        </mat-error>
                        <mat-error *ngIf="passengers.at(i).get('passportDateOfExpire')?.hasError('required')">
                          Необходимо заполнить поле!
                        </mat-error>
                      </mat-form-field>
                    </div>
                    <button *ngIf="this.orderForm.get('passengers')?.value.length > 1" class="button delete"
                            (click)="removePassenger(i)">
                      <mat-icon>close</mat-icon>
                    </button>
                  </mat-card>
                </div>
              </ng-container>

              <div class="form-buttons">
                <button type="reset" mat-stroked-button color="primary" (click)="resetForm()">Reset</button>
                <button type="submit" mat-stroked-button color="primary" (click)="sendForm()">Send</button>
              </div>

            </form>
          </ng-container>
        </ng-container>
      </ng-container>
    </mat-card-content>
  </mat-card>
</div>
